@import '~modularscale-sass/stylesheets/modularscale'
$modularscale: (base: 1em, ratio: $major-second)

$input-color: $grey-darker !default
$input-background-color: $white !default
$input-border-color: nth($blue-grey-lighten, 4) !default
$input-shadow: inset 0 1px 3px 0 rgba($black, 0) !default

$input-hover-color: $blue-grey !default
$input-hover-border-color: nth($blue-grey-lighten, 3) !default

$input-focus-color: $grey-darker !default
$input-focus-border-color: nth($blue-grey-lighten, 2) !default
$input-focus-box-shadow-size: 0 0 .25rem 0.125em !default
$input-focus-box-shadow-color: nth($blue-grey-lighten, 4) !default

$input-disabled-color: $text-light !default
$input-disabled-background-color: $background !default
$input-disabled-border-color: $background !default

$input-arrow: $link !default

$input-icon-color: nth($blue-grey-lighten, 3) !default
$input-icon-active-color: $grey !default

$input-radius: $radius !default

$file-border-color: $border !default
$file-radius: $radius !default

$file-cta-background-color: $white-ter !default
$file-cta-color: $grey-dark !default
$file-cta-hover-color: $grey-darker !default
$file-cta-active-color: $grey-darker !default

$file-name-border-color: $border !default
$file-name-border-style: solid !default
$file-name-border-width: 1px 1px 1px 0 !default
$file-name-max-width: 16em !default

$label-color: $blue-grey !default
$label-weight: $weight-normal !default

$help-size: .8rem !default

=input
  +control
  background-color: $input-background-color
  border-color: nth($blue-grey-lighten, 4)
  color: $input-color
  box-shadow: none
  +placeholder
    color: rgba($input-color, 0.3)
  &:hover,
  &.is-hovered
    border-color: $input-hover-border-color
  &:focus,
  &.is-focused,
  &:active,
  &.is-active
    border-color: $input-focus-border-color
    box-shadow: inset 0 1px 2px rgba(0,0,0,0), $input-focus-box-shadow-size $input-focus-box-shadow-color
  &[disabled]
    background-color: $input-disabled-background-color
    border-color: $input-disabled-border-color
    box-shadow: none
    color: $input-disabled-color
    +placeholder
      color: rgba($input-disabled-color, 0.3)

.#{$namespace}-input,
.#{$namespace}-textarea
  +input
  box-shadow: $input-shadow
  max-width: 100%
  width: 100%
  transition: $speed $easing
  &[readonly]
    box-shadow: none
  // Colors
  @each $name, $pair in $colors
    $color: nth($pair, 1)
    &.is-#{$name}
      border-color: $color
      &:focus,
      &.is-focused,
      &:active,
      &.is-active
        box-shadow: $input-focus-box-shadow-size rgba($color, 0.25)
  // Sizes
  &.is-small
    +control-small
  &.is-medium
    +control-medium
  &.is-large
    +control-large
  // Modifiers
  &.is-fullwidth
    display: block
    width: 100%
  &.is-inline
    display: inline
    width: auto

.#{$namespace}-input
  &.is-rounded
    border-radius: $radius-rounded
    padding-left: 1em
    padding-right: 1em
  &.is-static
    background-color: transparent
    border-color: transparent
    box-shadow: none
    padding-left: 0
    padding-right: 0

.#{$namespace}-textarea
  display: block
  max-width: 100%
  min-width: 100%
  padding: 0.625em
  resize: vertical
  &:not([rows])
    max-height: 600px
    min-height: 120px
  &[rows]
    height: initial
  // Modifiers
  &.has-fixed-size
    resize: none

.#{$namespace}-select
  // display: inline-flex
  max-width: 100%
  position: relative
  vertical-align: top
  align-items: center
  &:not(.is-multiple)
    // height: 2.5em
  &:not(.is-multiple):not(.is-loading)
    &::after
      // +arrow($input-arrow)
      // right: 1.125em
      // z-index: 4
  &.is-rounded
    select
      border-radius: $radius-rounded
      padding-left: 1em
  & + .#{$namespace}-help
    transform: translateY(0)
    opacity: 1
  select
    +input
    cursor: pointer
    display: block
    font-size: 1em
    max-width: 100%
    outline: none
    &::-ms-expand
      display: none
    &[disabled]:hover
      border-color: $input-disabled-border-color
    &:not([multiple])
      padding-right: 2.5em
    &[multiple]
      height: initial
      padding: 0
      option
        padding: 0.5em 1em
  // States
  &:not(.is-multiple):not(.is-loading):hover
    &::after
      // border-color: $input-hover-color
  // Colors
  @each $name, $pair in $colors
    $color: nth($pair, 1)
    &.is-#{$name}
      &:not(:hover)::after
        // border-color: $color
      select
        border-color: $color
        &:hover,
        &.is-hovered
          border-color: darken($color, 5%)
        &:focus,
        &.is-focused,
        &:active,
        &.is-active
          box-shadow: $input-focus-box-shadow-size rgba($color, 0.25)
  // Sizes
  &.is-small
    +control-small
  &.is-medium
    +control-medium
  &.is-large
    +control-large
  // Modifiers
  &.is-disabled
    &::after
      // border-color: $input-disabled-color
  &.is-fullwidth
    width: 100%
    select
      width: 100%
  &.is-loading
    &::after
      +loader
      margin-top: 0
      position: absolute
      right: 0.625em
      top: 0.625em
      transform: none
    // &.is-small:after
    //   font-size: ms(-1)
    // &.is-medium:after
    //   font-size: ms(0)
    // &.is-large:after
    //   font-size: ms(1)

.#{$namespace}-file
  +unselectable
  align-items: stretch
  display: flex
  justify-content: flex-start
  position: relative
  // Colors
  @each $name, $pair in $colors
    $color: nth($pair, 1)
    $color-invert: nth($pair, 2)
    &.is-#{$name}
      .file-cta
        background-color: $color
        border-color: transparent
        color: $color-invert
      &:hover,
      &.is-hovered
        .file-cta
          background-color: darken($color, 2.5%)
          border-color: transparent
          color: $color-invert
      &:focus,
      &.is-focused
        .file-cta
          border-color: transparent
          box-shadow: 0 0 0.5em rgba($color, 0.25)
          color: $color-invert
      &:active,
      &.is-active
        .file-cta
          background-color: darken($color, 5%)
          border-color: transparent
          color: $color-invert
  // Sizes
  &.is-small
    font-size: ms(-1)
  &.is-medium
    font-size: ms(0)
    .file-icon
      .fa
        font-size: 21px
  &.is-large
    font-size: ms(1)
    .file-icon
      .fa
        font-size: 28px
  // Modifiers
  &.has-name
    .file-cta
      border-bottom-right-radius: 0
      border-top-right-radius: 0
    .file-name
      border-bottom-left-radius: 0
      border-top-left-radius: 0
    &.is-empty
      .file-cta
        border-radius: $file-radius
      .file-name
        display: none
  &.is-boxed
    .file-label
      flex-direction: column
    .file-cta
      flex-direction: column
      height: auto
      padding: 1em 3em
    .file-name
      border-width: 0 1px 1px
    .file-icon
      height: 1.5em
      width: 1.5em
      .fa
        font-size: 21px
    &.is-small
      .file-icon .fa
        font-size: 14px
    &.is-medium
      .file-icon .fa
        font-size: 28px
    &.is-large
      .file-icon .fa
        font-size: 35px
    &.has-name
      .file-cta
        border-radius: $file-radius $file-radius 0 0
      .file-name
        border-radius: 0 0 $file-radius $file-radius
        border-width: 0 1px 1px
  &.is-centered
    justify-content: center
  &.is-fullwidth
    .file-label
      width: 100%
    .file-name
      flex-grow: 1
      max-width: none
  &.is-right
    justify-content: flex-end
    .file-cta
      border-radius: 0 $file-radius $file-radius 0
    .file-name
      border-radius: $file-radius 0 0 $file-radius
      border-width: 1px 0 1px 1px
      order: -1

.#{$namespace}-file-label
  align-items: stretch
  display: flex
  cursor: pointer
  justify-content: flex-start
  overflow: hidden
  position: relative
  &:hover
    .file-cta
      background-color: darken($file-cta-background-color, 2.5%)
      color: $file-cta-hover-color
    .file-name
      border-color: darken($file-name-border-color, 2.5%)
  &:active
    .file-cta
      background-color: darken($file-cta-background-color, 5%)
      color: $file-cta-active-color
    .file-name
      border-color: darken($file-name-border-color, 5%)

.#{$namespace}-file-input
  height: 0.01em
  left: 0
  outline: none
  position: absolute
  top: 0
  width: 0.01em

.#{$namespace}-file-cta,
.#{$namespace}-file-name
  +control
  border-color: $file-border-color
  border-radius: $file-radius
  font-size: 1em
  padding-left: 1em
  padding-right: 1em
  white-space: nowrap

.#{$namespace}-file-cta
  background-color: $file-cta-background-color
  color: $file-cta-color

.#{$namespace}-file-name
  border-color: $file-name-border-color
  border-style: $file-name-border-style
  border-width: $file-name-border-width
  display: block
  max-width: $file-name-max-width
  overflow: hidden
  text-align: left
  text-overflow: ellipsis

.#{$namespace}-file-icon
  align-items: center
  display: flex
  height: 1em
  justify-content: center
  margin-right: 0.5em
  width: 1em
  .fa
    font-size: ms(-1)

.#{$namespace}-label
  font-size: ms(-2)
  color: $label-color
  display: block
  text-transform: uppercase
  font-weight: $label-weight
  +desktop
    font-size: ms(-1)
  &:not(:last-child)
    margin-bottom: 0.25rem

    sup
      position: relative
      top: .2rem
  // Sizes
  &.is-small
    font-size: ms(-2)
  &.is-medium
    font-size: ms(-1)
  &.is-large
    font-size: ms(0)

.#{$namespace}-help
  display: block
  font-size: ms(-2)
  width: 100%
  letter-spacing: .025rem
  color: nth($blue-grey-lighten, 1)
  margin-top: 0.25rem
  transition: $speed $easing
  @each $name, $pair in $colors
    $color: nth($pair, 1)
    &.is-#{$name}
      color: $color

// Containers
.#{$namespace}-input-control
  font-size: $size-normal
  position: relative
  text-align: left
  // Modifiers
  .#{$namespace}-icon
    // font-size: $size-medium
    // * 
      // font-size: $size-3
  // DEPRECATED
  &.has-icon
    .#{$namespace}-icon
      color: $input-icon-color
      height: 2.5em
      pointer-events: none
      position: absolute
      top: 0
      width: 2.5em
      z-index: 4
    .#{$namespace}-input
      &:focus
        & + .#{$namespace}-icon
          color: $input-icon-active-color
      &.is-small
        & + .#{$namespace}-icon
          font-size: $size-small
      &.is-medium
        & + .#{$namespace}-icon
          font-size: $size-medium
      &.is-large
        & + .#{$namespace}-icon
          font-size: $size-large
    &:not(.has-icon-right)
      .#{$namespace}-icon
        left: 0
      .#{$namespace}-input
        padding-left: 2.5em
    &.has-icon-right
      .#{$namespace}-icon
        right: 0
      .#{$namespace}-input
        padding-right: 2.5em
  &.has-icons-left,
  &.has-icons-right
    .#{$namespace}-input,
    .#{$namespace}-select
      &:focus
        & ~ .#{$namespace}-icon
          color: $input-icon-active-color
      & ~ .#{$namespace}-icon
        font-size: $icon-dimensions-small
        > * 
          font-size: $icon-dimensions
      &.is-small ~ .#{$namespace}-icon
        font-size: $size-small
        > *
          font-size: $icon-dimensions-small
      &.is-medium ~ .#{$namespace}-icon
        font-size: $size-medium
        > *
          font-size: $icon-dimensions-medium
      &.is-large ~ .#{$namespace}-icon
        font-size: $size-large
        > *
          font-size: $icon-dimensions-large
    .#{$namespace}-icon
      color: $input-icon-color
      height: 2.5em
      pointer-events: none
      position: absolute
      top: 0
      width: 2.5em
      z-index: 4
  &.has-icons-left
    .#{$namespace}-input,
    .#{$namespace}-select select
      padding-left: 2.5em
    .#{$namespace}-icon.is-left
      left: 0
  &.has-icons-right
    .#{$namespace}-input,
    .#{$namespace}-select select
      padding-right: 2.5em
    .#{$namespace}-icon.is-right
      right: 0
  &.is-loading
    &::after
      +loader
      position: absolute !important
      right: 0.625em
      top: 0.625em
      z-index: 4
    &.is-small:after
      font-size: $size-small
    &.is-medium:after
      font-size: $size-medium
    &.is-large:after
      font-size: $size-large

// input:-webkit-autofill
//   border-top: 1px solid nth($blue-grey-lighten, 4) !important
//   border-bottom: 1px solid nth($blue-grey-lighten, 4) !important
//   border-radius: 0 !important
//   -webkit-text-fill-color: $black-bis !important
//   background-color: white !important
//   -webkit-box-shadow: 0 0 0px 1000px white inset
//   transition: background-color 5000s ease-in-out 0s
// input:-webkit-autofill:hover,
// input:-webkit-autofill:focus,
// input:-webkit-autofill:active
//   border-top: 1px solid nth($blue-grey-lighten, 3) !important
//   border-bottom: 1px solid nth($blue-grey-lighten, 3) !important
//   background-color: white !important
//   -webkit-box-shadow: 0 0 0px 1000px white inset
//   transition: background-color 5000s ease-in-out 0s

.#{$namespace}-multifield-input
  display: flex
  flex-wrap: wrap
  justify-content: center
  .#{$namespace}-field
    flex-grow: 1
    flex-shrink: 1
    flex-basis: 8%
    
    +tablet 
      flex-grow: 0

    .#{$namespace}-input
      font-size: 1.4em
      height: auto
      min-height: 2em
      text-align: center
      padding: 0em

  &>.#{$namespace}-field + .#{$namespace}-field
    margin-left: 0.5em

@import 'form-checkbox-radio.sass'
// @import 'form-input-group.sass'
@import 'field.sass'